<div
  [ngClass]="{
    'w-full lg:border-b-2 lg:border-gray-200': true,
    'hidden lg:block': !openned,
    'block fixed w-full h-screen z-50 bg-white top-0 left-0 overflow-y-auto':
      openned
  }"
>
  <div
    [ngClass]="{
      'w-full m-auto xl:max-w-screen-xl 2xl:max-w-screen-2xl px-8 xl:px-4 py-2 flex':
        !openned,
      'w-full p-4 flex flex-col': openned
    }"
  >
    <span class="mb-8 cursor-pointer" *ngIf="openned" (click)="toggleFilter()"
      ><i class="bi bi-chevron-left"></i> Cancelar</span
    >
    <h2
      class="text-xl font-bold text-gray-800 block col-span-1 lg:col-span-2"
      *ngIf="openned"
    >
      Filtrar resultados
    </h2>

    <div class="relative lg:flex lg:flex-wrap">
      <div>
        <span
          (click)="dropDown('location')"
          [ngClass]="{
            'py-2 block px-3 border-2 mr-2 rounded cursor-pointer hover:border-odb-400 hover:bg-odb-50 hover:text-odb-400': true,
            'border-odb-400 text-odb-400 bg-odb-50':
              dropedDown === 'location' ||
              queryParams['provinceID'] ||
              queryParams['municipalityID'],
            'hidden mb-4': openned
          }"
        >
          <i class="bi bi-geo-alt-fill"></i> Ubicación
          <i class="bi bi-chevron-down ml-2" *ngIf="dropedDown != 'price'"></i>
          <i class="bi bi-chevron-up ml-2" *ngIf="dropedDown === 'price'"></i
        ></span>

        <div
          *ngIf="dropedDown === 'location' || openned"
          class="w-full lg:w-fit mb-2 bg-white border-2 p-3 lg:absolute rounded top-100 flex flex-col lg:drop-shadow-xl lg:grid lg:grid-cols-2"
        >
          <h2
            class="text-lg font-bold text-gray-800 lg:col-span-1 mb-2 lg:mb-0"
          >
            Ubicación
          </h2>
          <span
            class="underline cursor-pointer text-odb-800 hover:text-odb-400 text-sm col-span-1 lg:block lg:w-fit lg:ml-auto lg:self-center"
            (click)="clearLocation()"
            >Limpiar selección</span
          >
          <hr class="col-span-2 mt-2" />
          <div class="relative lg:col-span-2">
            <input
              [ngClass]="{
                'p-2 text-md border-2 my-4 rounded w-full relative': true
              }"
              type="text"
              placeholder="Buscar en provincia, municipio..."
              [value]="currentSearch != '' ? currentSearch : ''"
              #inputSearch
              (keyup)="searchByWords(inputSearch.value)"
              (keyup)="currentSearch = inputSearch.value"
              (keyup.enter)="buyByLocation()"
              required
            />
            <span
              *ngIf="searching"
              class="absolute top-0 right-0 mt-7 mr-2 w-6 h-6 bg-transparent border-4 border-t-odb-400 border-r-odb-400 rounded-full animate-spin transition-all"
            ></span>
            <div
              class="bg-white w-full absolute top-100 left-0 p-1 rounded-b border-2 drop-shadow-xl"
              *ngIf="provinces.length > 0 || municipalities.length > 0"
            >
              <ul>
                <li
                  class="block text-lg p-2 hover:bg-gray-200 cursor-pointer rounded"
                  *ngFor="let item of provinces"
                  (click)="clickOnResults('province', item.id)"
                >
                  {{ item.name }}
                  <span
                    class="block tracking-wide uppercase text-xxs text-odb-500 font-bold"
                    ><i class="bi bi-geo-alt-fill"></i>Provincia</span
                  >
                </li>
                <li
                  class="block text-lg p-2 hover:bg-gray-200 cursor-pointer rounded"
                  *ngFor="let item of municipalities"
                  (click)="clickOnResults('municipality', item.id)"
                >
                  {{ item.name }}
                  <span
                    class="block tracking-wide uppercase text-xxs text-odb-500 font-bold"
                    ><i class="bi bi-geo-alt-fill"></i>Municipio</span
                  >
                </li>
              </ul>
            </div>
          </div>
          <button
            (click)="buyByLocation()"
            [ngClass]="{
              'hidden lg:block px-4 col-span-2 py-1.5 bg-odb-400 text-white font-medium rounded cursor-pointer transition-all hover:text-white hover:bg-odb-800 border-2 border-odb-400': true
            }"
          >
            Buscar
          </button>
        </div>
      </div>

      <div>
        <span
          (click)="dropDown('type')"
          [ngClass]="{
            'py-2 block px-3 border-2 mr-2 rounded cursor-pointer hover:border-odb-400 hover:bg-odb-50 hover:text-odb-400': true,
            'border-odb-400 text-odb-400 bg-odb-50':
              dropedDown === 'type' ||
              (queryParams['type'] && queryParams['type'] != ''),
            'hidden mb-4': openned
          }"
        >
          Tipo de inmueble
          <span *ngIf="selectedTypes.length > 0"
            >({{ selectedTypes.length }})</span
          >
          <i class="bi bi-chevron-down ml-2" *ngIf="dropedDown != 'type'"></i>
          <i class="bi bi-chevron-up ml-2" *ngIf="dropedDown === 'type'"></i
        ></span>

        <div
          *ngIf="dropedDown === 'type' || openned"
          class="my-2 lg:my-0 w-fit bg-white border-2 p-3 lg:absolute rounded top-100 lg:drop-shadow-xl flex flex-col lg:grid lg:grid-cols-2"
        >
          <h2 class="text-lg font-bold text-gray-800 lgcol-span-1 mb-2 lg:mb-0">
            Tipo de inmueble
          </h2>
          <span
            class="underline cursor-pointer text-odb-800 hover:text-odb-400 text-sm col-span-1 block lg:w-fit lg:ml-auto lg:self-center"
            (click)="clearTypes()"
            >Limpiar selección</span
          >
          <ul class="columns-2 lg:col-span-2 my-2 py-2 border-t-2">
            <ng-container *ngFor="let type of types">
              <li>
                <label class="ml-2 mb-1 block">
                  <input
                    type="checkbox"
                    class="mr-1"
                    (change)="selectTypes(type.id)"
                    [value]="type.id"
                    [checked]="selectedTypes.includes(type.id)"
                  />{{ type.name }}</label
                >
              </li>
            </ng-container>
          </ul>
          <button
            (click)="applyFilter()"
            class="hidden lg:block px-4 py-1.5 mt-2 w-full col-span-2 bg-odb-400 text-white font-medium rounded cursor-pointer transition-all hover:text-white hover:bg-odb-800 border-2 border-odb-400"
          >
            Aplicar
          </button>
        </div>
      </div>

      <div *ngIf="selectedTypes.length > 0">
        <span
          (click)="dropDown('subtype')"
          [ngClass]="{
            'py-2 block px-3 border-2 mr-2 rounded cursor-pointer hover:border-odb-400 hover:bg-odb-50 hover:text-odb-400': true,
            'border-odb-400 text-odb-400 bg-odb-50':
              dropedDown === 'subtype' ||
              (queryParams['subtype'] && queryParams['subtype'] != ''),
            'hidden mb-4': openned
          }"
        >
          Subtipo de inmueble
          <span *ngIf="subTypesSelected.length > 0"
            >({{ subTypesSelected.length }})</span
          >
          <i
            class="bi bi-chevron-down ml-2"
            *ngIf="dropedDown != 'subtype'"
          ></i>
          <i class="bi bi-chevron-up ml-2" *ngIf="dropedDown === 'subtype'"></i
        ></span>

        <div
          *ngIf="dropedDown === 'subtype' || openned"
          class="my-2 lg:my-0 w-fit bg-white border-2 p-3 lg:absolute rounded top-100 lg:drop-shadow-xl flex flex-col lg:grid lg:grid-cols-2"
        >
          <h2 class="text-lg font-bold text-gray-800 lgcol-span-1 mb-2 lg:mb-0">
            Subtipo de inmueble
          </h2>
          <span
            class="underline cursor-pointer text-odb-800 hover:text-odb-400 text-sm col-span-1 block lg:w-fit lg:ml-auto lg:self-center"
            (click)="clearTypes()"
            >Limpiar selección</span
          >
          <ul class="columns-2 lg:col-span-2 my-2 py-2 border-t-2">
            <ng-container *ngFor="let subtype of subTypesToShow">
              <li>
                <label class="ml-2 mb-1 block">
                  <input
                    type="checkbox"
                    class="mr-1"
                    (change)="selectSubTypes(subtype.id)"
                    [value]="subtype.id"
                    [checked]="subTypesSelected.includes(subtype.id)"
                  />{{ subtype.name }}</label
                >
              </li>
            </ng-container>
          </ul>
          <button
            (click)="applyFilter()"
            class="hidden lg:block px-4 py-1.5 mt-2 w-full col-span-2 bg-odb-400 text-white font-medium rounded cursor-pointer transition-all hover:text-white hover:bg-odb-800 border-2 border-odb-400"
          >
            Aplicar
          </button>
        </div>
      </div>

      <div>
        <span
          (click)="dropDown('price')"
          [ngClass]="{
            'py-2 block px-3 border-2 mr-2 rounded cursor-pointer hover:border-odb-400 hover:bg-odb-50 hover:text-odb-400': true,
            'border-odb-400 text-odb-400 bg-odb-50':
              dropedDown === 'price' ||
              (queryParams['priceFrom'] && queryParams['priceFrom'] != '0') ||
              (queryParams['priceTo'] && queryParams['priceTo'] != '0'),
            'hidden mb-4': openned
          }"
        >
          Precio
          <i class="bi bi-chevron-down ml-2" *ngIf="dropedDown != 'price'"></i>
          <i class="bi bi-chevron-up ml-2" *ngIf="dropedDown === 'price'"></i
        ></span>

        <div
          *ngIf="dropedDown === 'price' || openned"
          class="w-full lg:w-fit mb-2 bg-white border-2 p-3 lg:absolute rounded top-100 flex flex-col lg:drop-shadow-xl lg:grid lg:grid-cols-2"
        >
          <h2
            class="text-lg font-bold text-gray-800 lg:col-span-1 mb-2 lg:mb-0"
          >
            Rango de precios
          </h2>
          <span
            class="underline cursor-pointer text-odb-800 hover:text-odb-400 text-sm col-span-1 lg:block lg:w-fit lg:ml-auto lg:self-center"
            (click)="clearPrices()"
            >Limpiar selección</span
          >
          <div
            class="flex flex-col lg:grid lg:grid-cols-2 my-2 py-2 border-t-2 lg:col-span-2"
          >
            <label
              for="rangePriceFrom"
              class="lg:col-span-1 lg:pr-1 mb-2 lg:mb-0"
              >Mínimo
              <input
                type="number"
                class="block p-1 mb-2 border-2 rounded w-full lg:w-48"
                #rangePriceFrom
                name="rangePriceFrom"
                [value]="
                  queryParams['priceFrom'] ? queryParams['priceFrom'] : 0
                "
                (input)="priceFrom = rangePriceFrom.value"
                min="0"
                max="999999999"
              />
            </label>
            <label for="rangePriceTo" class="lg:col-span-1 lg:pl-1"
              >Máximo
              <input
                type="number"
                class="block p-1 mb-2 border-2 rounded w-full lg:w-48"
                #rangePriceTo
                name="rangePriceTo"
                [value]="queryParams['priceTo'] ? queryParams['priceTo'] : 0"
                (input)="priceTo = rangePriceTo.value"
                min="0"
                max="999999999"
              />
            </label>
          </div>

          <button
            (click)="applyFilter()"
            [ngClass]="{
              'hidden lg:block px-4 col-span-2 py-1.5 bg-odb-400 text-white font-medium rounded cursor-pointer transition-all hover:text-white hover:bg-odb-800 border-2 border-odb-400': true,
              'pointer-events-none opacity-50':
                priceFrom === '0' && priceTo === '0'
            }"
          >
            Aplicar
          </button>
        </div>
      </div>

      <div>
        <span
          (click)="dropDown('surface')"
          [ngClass]="{
            'py-2 block px-3 border-2 mr-2 rounded cursor-pointer hover:border-odb-400 hover:bg-odb-50 hover:text-odb-400': true,
            'border-odb-400 text-odb-400 bg-odb-50':
              dropedDown === 'surface' ||
              (queryParams['fromSQM'] && queryParams['fromSQM'] != '0') ||
              (queryParams['toSQM'] && queryParams['toSQM'] != '0'),
            'hidden mb-4': openned
          }"
        >
          Superficie
          <i
            class="bi bi-chevron-down ml-2"
            *ngIf="dropedDown != 'surface'"
          ></i>
          <i class="bi bi-chevron-up ml-2" *ngIf="dropedDown === 'surface'"></i
        ></span>

        <div
          *ngIf="dropedDown === 'surface' || openned"
          class="w-full lg:w-fit mb-2 lg:mb-0 bg-white border-2 p-3 lg:absolute rounded top-100 lg:drop-shadow-xl flex flex-col lg:grid lg:grid-cols-2"
        >
          <h2 class="text-lg font-bold text-gray-800 col-span-1 mb-2 lg:mb-0">
            Rango de superficie
          </h2>
          <span
            class="underline cursor-pointer text-odb-800 hover:text-odb-400 text-sm col-span-1 block lg:w-fit lg:ml-auto lg:self-center"
            (click)="clearSurface()"
            >Limpiar selección</span
          >
          <div class="grid grid-cols-2 my-2 py-2 border-t-2 col-span-2">
            <label for="rangeFromSQM" class="col-span-1 pr-1"
              >Mínimo
              <input
                type="number"
                class="block p-1 mb-2 border-2 rounded w-full lg:w-48"
                #rangeFromSQM
                name="rangeFromSQM"
                [value]="queryParams['fromSQM'] ? queryParams['fromSQM'] : 0"
                (input)="fromSQM = rangeFromSQM.value"
                min="0"
                max="999999999"
              />
            </label>
            <label for="rangeToSQM" class="col-span-1 pl-1"
              >Máximo
              <input
                type="number"
                class="block p-1 mb-2 border-2 rounded w-full lg:w-48"
                #rangeToSQM
                name="rangeToSQM"
                [value]="queryParams['toSQM'] ? queryParams['toSQM'] : 0"
                (input)="toSQM = rangeToSQM.value"
                min="0"
                max="999999999"
              />
            </label>
          </div>

          <button
            (click)="applyFilter()"
            [ngClass]="{
              'hidden lg:block px-4 col-span-2 py-1.5 bg-odb-400 text-white font-medium rounded cursor-pointer transition-all hover:text-white hover:bg-odb-800 border-2 border-odb-400': true,
              'pointer-events-none opacity-50': fromSQM === '0' && toSQM === '0'
            }"
          >
            Aplicar
          </button>
        </div>
      </div>

      <div *ngIf="selectedTypes.length === 0 || selectedTypes.includes(1)">
        <span
          (click)="dropDown('rooms')"
          [ngClass]="{
            'py-2 block px-3 border-2 mr-2 rounded cursor-pointer hover:border-odb-400 hover:bg-odb-50 hover:text-odb-400': true,
            'border-odb-400 text-odb-400 bg-odb-50':
              dropedDown === 'rooms' || rooms != 0,
            'hidden mb-4': openned
          }"
        >
          Habitaciones <span *ngIf="rooms > 0">({{ rooms }}+)</span>
          <i class="bi bi-chevron-down ml-2" *ngIf="dropedDown != 'rooms'"></i>
          <i class="bi bi-chevron-up ml-2" *ngIf="dropedDown === 'rooms'"></i
        ></span>

        <div
          *ngIf="dropedDown === 'rooms' || openned"
          class="w-fit bg-white border-2 p-3 lg:absolute rounded top-100 mb-2 lg:mb-0 lg:drop-shadow-xl flex flex-col lg:grid lg:grid-cols-2"
        >
          <h2 class="text-lg font-bold text-gray-800 col-span-1">
            Habitaciones
          </h2>
          <div
            class="flex flex-wrap lg:flex-row my-2 py-2 border-t-2 col-span-2"
          >
            <button
              (click)="rooms = 0"
              [ngClass]="{
                'px-4 col-span-2 py-1.5 bg-white text-odb-400 w-fit font-medium rounded lg:rounded-none lg:rounded-l mr-1 mb-1 lg:m-0 cursor-pointer transition-all hover:text-white hover:bg-odb-800 border-2 lg:border-r-0 border-odb-400': true,
                'bg-odb-400 text-white': rooms === 0
              }"
            >
              Todas
            </button>
            <button
              (click)="rooms = 1"
              [ngClass]="{
                'px-4 col-span-2 py-1.5 bg-white text-odb-400 w-fit font-medium rounded lg:rounded-none cursor-pointer mr-1 mb-1 lg:m-0 transition-all hover:text-white hover:bg-odb-800 border-2 lg:border-r-0 border-odb-400': true,
                'bg-odb-400 text-white': rooms === 1
              }"
            >
              1+
            </button>
            <button
              (click)="rooms = 2"
              [ngClass]="{
                'px-4 col-span-2 py-1.5 bg-white text-odb-400 w-fit font-medium rounded lg:rounded-none cursor-pointer mr-1 mb-1 lg:m-0 transition-all hover:text-white hover:bg-odb-800 border-2 lg:border-r-0 border-odb-400': true,
                'bg-odb-400 text-white': rooms === 2
              }"
            >
              2+
            </button>
            <button
              (click)="rooms = 3"
              [ngClass]="{
                'px-4 col-span-2 py-1.5 bg-white text-odb-400 w-fit font-medium rounded lg:rounded-none cursor-pointer mr-1 mb-1 lg:m-0 transition-all hover:text-white hover:bg-odb-800 border-2 lg:border-r-0 border-odb-400': true,
                'bg-odb-400 text-white': rooms === 3
              }"
            >
              3+
            </button>
            <button
              (click)="rooms = 4"
              [ngClass]="{
                'px-4 col-span-2 py-1.5 bg-white text-odb-400 w-fit font-medium rounded lg:rounded-none lg:rounded-r cursor-pointer mr-1 mb-1 lg:m-0 transition-all hover:text-white hover:bg-odb-800 border-2 border-odb-400': true,
                'bg-odb-400 text-white': rooms === 4
              }"
            >
              4+
            </button>
          </div>

          <button
            (click)="applyFilter()"
            [ngClass]="{
              'hidden lg:block px-4 col-span-2 py-1.5 bg-odb-400 text-white font-medium rounded cursor-pointer transition-all hover:text-white hover:bg-odb-800 border-2 border-odb-400': true
            }"
          >
            Aplicar
          </button>
        </div>
      </div>

      <div *ngIf="selectedTypes.length === 0 || selectedTypes.includes(1)">
        <span
          (click)="dropDown('baths')"
          [ngClass]="{
            'py-2 block px-3 border-2 mr-2 rounded cursor-pointer hover:border-odb-400 hover:bg-odb-50 hover:text-odb-400': true,
            'border-odb-400 text-odb-400 bg-odb-50':
              dropedDown === 'baths' || baths != 0,
            'hidden mb-4': openned
          }"
        >
          Baños <span *ngIf="baths > 0">({{ baths }}+)</span>
          <i class="bi bi-chevron-down ml-2" *ngIf="dropedDown != 'baths'"></i>
          <i class="bi bi-chevron-up ml-2" *ngIf="dropedDown === 'baths'"></i
        ></span>

        <div
          *ngIf="dropedDown === 'baths' || openned"
          class="w-fit bg-white border-2 p-3 lg:absolute rounded top-100 lg:drop-shadow-xl flex flex-col lg:grid lg:grid-cols-2"
        >
          <h2 class="text-lg font-bold text-gray-800 col-span-1">Baños</h2>
          <div class="flex flex-row my-2 py-2 border-t-2 col-span-2">
            <button
              (click)="baths = 0"
              [ngClass]="{
                'px-4 col-span-2 py-1.5 bg-white text-odb-400 w-fit font-medium rounded lg:rounded-none lg:rounded-l mr-1 mb-1 lg:m-0 cursor-pointer transition-all hover:text-white hover:bg-odb-800 border-2 lg:border-r-0 border-odb-400': true,
                'bg-odb-400 text-white': baths === 0
              }"
            >
              Todas
            </button>
            <button
              (click)="baths = 1"
              [ngClass]="{
                'px-4 col-span-2 py-1.5 bg-white text-odb-400 w-fit font-medium rounded lg:rounded-none cursor-pointer mr-1 mb-1 lg:m-0 transition-all hover:text-white hover:bg-odb-800 border-2 lg:border-r-0 border-odb-400': true,
                'bg-odb-400 text-white': baths === 1
              }"
            >
              1+
            </button>
            <button
              (click)="baths = 2"
              [ngClass]="{
                'px-4 col-span-2 py-1.5 bg-white text-odb-400 w-fit font-medium rounded lg:rounded-none cursor-pointer mr-1 mb-1 lg:m-0 transition-all hover:text-white hover:bg-odb-800 border-2 lg:border-r-0 border-odb-400': true,
                'bg-odb-400 text-white': baths === 2
              }"
            >
              2+
            </button>
            <button
              (click)="baths = 3"
              [ngClass]="{
                'px-4 col-span-2 py-1.5 bg-white text-odb-400 w-fit font-medium rounded lg:rounded-none lg:rounded-r cursor-pointer mr-1 mb-1 lg:m-0 transition-all hover:text-white hover:bg-odb-800 border-2 border-odb-400': true,
                'bg-odb-400 text-white': baths === 3
              }"
            >
              3+
            </button>
          </div>

          <button
            (click)="applyFilter()"
            [ngClass]="{
              'hidden lg:block px-4 col-span-2 py-1.5 bg-odb-400 text-white font-medium rounded cursor-pointer transition-all hover:text-white hover:bg-odb-800 border-2 border-odb-400': true
            }"
          >
            Aplicar
          </button>
        </div>
      </div>
    </div>

    <button
      *ngIf="openned"
      (click)="applyFilter()"
      class="px-16 py-2.5 w-fit m-auto mt-4 bg-odb-400 text-white block font-medium rounded cursor-pointer transition-all hover:text-white hover:bg-odb-800 border-2 border-odb-400"
    >
      Aplicar
    </button>
  </div>
</div>

<span
  class="block lg:hidden h-fit w-fit leading-5 bg-odb-500 text-white text-3xl p-4 rounded-full lg:drop-shadow-xl cursor-pointer bottom-5 right-5 z-40 fixed"
  (click)="toggleFilter()"
>
  <i class="bi bi-sliders"></i>
</span>
